test-lib.sh 6.1 KB
Newer Older
1 2 3 4 5 6 7
#!/bin/sh
#
# Copyright (c) 2005 Junio C Hamano
#

# For repeatability, reset the environment to known value.
LANG=C
8
LC_ALL=C
9
PAGER=cat
10
TZ=UTC
11
export LANG LC_ALL PAGER TZ
12 13
EDITOR=:
VISUAL=:
14 15 16 17 18
unset AUTHOR_DATE
unset AUTHOR_EMAIL
unset AUTHOR_NAME
unset COMMIT_AUTHOR_EMAIL
unset COMMIT_AUTHOR_NAME
19
unset EMAIL
20 21
unset GIT_ALTERNATE_OBJECT_DIRECTORIES
unset GIT_AUTHOR_DATE
22 23
GIT_AUTHOR_EMAIL=author@example.com
GIT_AUTHOR_NAME='A U Thor'
24
unset GIT_COMMITTER_DATE
25 26
GIT_COMMITTER_EMAIL=committer@example.com
GIT_COMMITTER_NAME='C O Mitter'
27 28
unset GIT_DIFF_OPTS
unset GIT_DIR
29
unset GIT_WORK_TREE
30 31 32 33 34
unset GIT_EXTERNAL_DIFF
unset GIT_INDEX_FILE
unset GIT_OBJECT_DIRECTORY
unset SHA1_FILE_DIRECTORIES
unset SHA1_FILE_DIRECTORY
35 36
GIT_MERGE_VERBOSITY=5
export GIT_MERGE_VERBOSITY
37 38
export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
39
export EDITOR VISUAL
40

41 42 43 44
# Protect ourselves from common misconfiguration to export
# CDPATH into the environment
unset CDPATH

45
case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
46 47 48 49 50 51 52 53
	1|2|true)
		echo "* warning: Some tests will not work if GIT_TRACE" \
			"is set as to trace on STDERR ! *"
		echo "* warning: Please set GIT_TRACE to something" \
			"other than 1, 2 or true ! *"
		;;
esac

54 55 56 57 58 59 60 61 62
# Each test should start with something like this, after copyright notices:
#
# test_description='Description of this test...
# This test checks if command xyzzy does the right thing...
# '
# . ./test-lib.sh

error () {
	echo "* error: $*"
63
	trap - exit
64 65 66 67 68 69 70 71 72 73 74 75 76 77 78
	exit 1
}

say () {
	echo "* $*"
}

test "${test_description}" != "" ||
error "Test script did not set test_description."

while test "$#" -ne 0
do
	case "$1" in
	-d|--d|--de|--deb|--debu|--debug)
		debug=t; shift ;;
J
Junio C Hamano 已提交
79 80
	-i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
		immediate=t; shift ;;
81 82 83 84 85
	-h|--h|--he|--hel|--help)
		echo "$test_description"
		exit 0 ;;
	-v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
		verbose=t; shift ;;
86
	--no-python)
J
Junio C Hamano 已提交
87 88
		# noop now...
		shift ;;
89 90 91 92 93
	*)
		break ;;
	esac
done

94
exec 5>&1
95 96 97 98 99 100 101 102 103 104
if test "$verbose" = "t"
then
	exec 4>&2 3>&1
else
	exec 4>/dev/null 3>/dev/null
fi

test_failure=0
test_count=0

105 106
trap 'echo >&5 "FATAL: Unexpected exit with code $?"; exit 1' exit

107 108 109
test_tick () {
	if test -z "${test_tick+set}"
	then
J
Junio C Hamano 已提交
110
		test_tick=1112911993
111 112 113
	else
		test_tick=$(($test_tick + 60))
	fi
J
Junio C Hamano 已提交
114 115
	GIT_COMMITTER_DATE="$test_tick -0700"
	GIT_AUTHOR_DATE="$test_tick -0700"
116 117
	export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
}
118

J
Junio C Hamano 已提交
119 120 121 122
# You are not expected to call test_ok_ and test_failure_ directly, use
# the text_expect_* functions instead.

test_ok_ () {
123
	test_count=$(expr "$test_count" + 1)
124
	say "  ok $test_count: $@"
125 126
}

J
Junio C Hamano 已提交
127
test_failure_ () {
128 129
	test_count=$(expr "$test_count" + 1)
	test_failure=$(expr "$test_failure" + 1);
130 131 132
	say "FAIL $test_count: $1"
	shift
	echo "$@" | sed -e 's/^/	/'
133
	test "$immediate" = "" || { trap - exit; exit 1; }
J
Junio C Hamano 已提交
134 135 136 137
}


test_debug () {
138
	test "$debug" = "" || eval "$1"
139 140
}

141 142 143 144 145 146
test_run_ () {
	eval >&3 2>&4 "$1"
	eval_ret="$?"
	return 0
}

147 148 149 150 151 152 153 154 155 156 157 158 159 160 161 162 163 164 165 166 167 168 169 170
test_skip () {
	this_test=$(expr "./$0" : '.*/\(t[0-9]*\)-[^/]*$')
	this_test="$this_test.$(expr "$test_count" + 1)"
	to_skip=
	for skp in $GIT_SKIP_TESTS
	do
		case "$this_test" in
		$skp)
			to_skip=t
		esac
	done
	case "$to_skip" in
	t)
		say >&3 "skipping test: $@"
		test_count=$(expr "$test_count" + 1)
		say "skip $test_count: $1"
		: true
		;;
	*)
		false
		;;
	esac
}

171
test_expect_failure () {
172
	test "$#" = 2 ||
173
	error "bug in the test script: not 2 parameters to test-expect-failure"
174
	if ! test_skip "$@"
175
	then
176 177 178 179 180 181 182 183
		say >&3 "expecting failure: $2"
		test_run_ "$2"
		if [ "$?" = 0 -a "$eval_ret" != 0 -a "$eval_ret" -lt 129 ]
		then
			test_ok_ "$1"
		else
			test_failure_ "$@"
		fi
184
	fi
185
	echo >&3 ""
186 187 188
}

test_expect_success () {
189
	test "$#" = 2 ||
190
	error "bug in the test script: not 2 parameters to test-expect-success"
191
	if ! test_skip "$@"
192
	then
193 194 195 196 197 198 199 200
		say >&3 "expecting success: $2"
		test_run_ "$2"
		if [ "$?" = 0 -a "$eval_ret" = 0 ]
		then
			test_ok_ "$1"
		else
			test_failure_ "$@"
		fi
201
	fi
202
	echo >&3 ""
203 204
}

205 206 207
test_expect_code () {
	test "$#" = 3 ||
	error "bug in the test script: not 3 parameters to test-expect-code"
208
	if ! test_skip "$@"
209
	then
210 211 212 213 214 215 216 217
		say >&3 "expecting exit code $1: $3"
		test_run_ "$3"
		if [ "$?" = 0 -a "$eval_ret" = "$1" ]
		then
			test_ok_ "$2"
		else
			test_failure_ "$@"
		fi
218
	fi
219
	echo >&3 ""
220 221
}

222 223 224 225 226 227 228 229 230
# Most tests can use the created repository, but some amy need to create more.
# Usage: test_create_repo <directory>
test_create_repo () {
	test "$#" = 1 ||
	error "bug in the test script: not 1 parameter to test-create-repo"
	owd=`pwd`
	repo="$1"
	mkdir "$repo"
	cd "$repo" || error "Cannot setup test environment"
231 232
	"$GIT_EXEC_PATH/git" init --template=$GIT_EXEC_PATH/templates/blt/ >/dev/null 2>&1 ||
	error "cannot run git init -- have you built things yet?"
233 234 235
	mv .git/hooks .git/hooks-disabled
	cd "$owd"
}
J
Junio C Hamano 已提交
236

237
test_done () {
238
	trap - exit
239
	case "$test_failure" in
240
	0)
241 242 243 244 245 246 247 248 249 250 251 252 253 254 255 256 257 258 259 260 261
		# We could:
		# cd .. && rm -fr trash
		# but that means we forbid any tests that use their own
		# subdirectory from calling test_done without coming back
		# to where they started from.
		# The Makefile provided will clean this test area so
		# we will leave things as they are.

		say "passed all $test_count test(s)"
		exit 0 ;;

	*)
		say "failed $test_failure among $test_count test(s)"
		exit 1 ;;

	esac
}

# Test the binaries we have just built.  The tests are kept in
# t/ subdirectory and are run in trash subdirectory.
PATH=$(pwd)/..:$PATH
J
Johannes Schindelin 已提交
262
GIT_EXEC_PATH=$(pwd)/..
J
Johannes Schindelin 已提交
263
GIT_TEMPLATE_DIR=$(pwd)/../templates/blt
264 265
GIT_CONFIG=.git/config
export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG
266

267 268
GITPERLLIB=$(pwd)/../perl/blib/lib:$(pwd)/../perl/blib/arch/auto/Git
export GITPERLLIB
269 270 271
test -d ../templates/blt || {
	error "You haven't built things yet, have you?"
}
272

E
Eric Wong 已提交
273 274 275 276 277 278
if ! test -x ../test-chmtime; then
	echo >&2 'You need to build test-chmtime:'
	echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
	exit 1
fi

279 280 281
# Test repository
test=trash
rm -fr "$test"
282 283
test_create_repo $test
cd "$test"
284 285 286 287 288 289 290 291 292 293 294 295 296 297 298 299 300 301 302

this_test=$(expr "./$0" : '.*/\(t[0-9]*\)-[^/]*$')
for skp in $GIT_SKIP_TESTS
do
	to_skip=
	for skp in $GIT_SKIP_TESTS
	do
		case "$this_test" in
		$skp)
			to_skip=t
		esac
	done
	case "$to_skip" in
	t)
		say >&3 "skipping test $this_test altogether"
		say "skip all tests in $this_test"
		test_done
	esac
done